/*************************************
 CardLink 0.1
 (C) APR 2005 Hynek Sladky
 sladky@mujmail.cz
*************************************/

#pragma pack(2)

#include <PalmOS.h>
#include <ExpansionMgr.h>
#include <VFSMgr.h>

#include <PalmChars.h>

// resources header
#include "CardLinkR.h"

/******** ToDo ********/
/**********************

- zmenit rozmer listu - zustava dole smeti!!!

- na skutecnem stroji s PalmOS5 to pri ukonceni aplikace hodi hlasku "MemoryMgr.c, Line:3654, FreeHandle" -> soft reset
  na simulatoru a POSE m125 to funguje bez problemu
- po vytvoreni linku to chce okno "Link successfully created."
- koliduje s Switch5 v4.4 a QuickLaunch v4.0 !!!

- zatim nemam formular pro nastaveni, ale az ho budu delat tak:
  - CreatorID vlastni aplikace nebo CardLink
  - nastaveni predpony/pripony pro vytvoreni jmena linku - asi jako string pro StrPrintF...
  - nastaveni cesty na kartu - je rychlejsi ho nechat pod listboxem...

- mozna i projiti RAM a oznaceni existujicich linku?
- menu: delete missing links, refresh all links? je otazka, co vsechno by se takto hromadne automaticky melo delat...
- pro me staci jen vytvareni linku...
- asi bude vyhodne udelat formular na nastaveni, protoze se bude jednoduse pridavat dalsi polozky, napr.
  keep app's creatorID

< musi vzniknout program (link), ktery po spusteni nakopiruje a spusti program z karty a po ukonceni ho zase smaze...
< kod tohoto programu bude pribaleny k CardLink jako 'code' 0010, 'code' 0011, 'data' 0010, 'pref' 0010, 'rloc' 0010
< odtud se bude kopirovat do zalozeneho linkovaciho souboru jako id 0000 a 0001
< preference: nastaveni cesty na kartu; snad bude stacit FrmCustomResponseAlert (viz GSMsync)
< projiti karty a vytvoreni listboxu
- tlactiko uz mam, jen ho umistit dolu...
< jeste je nutne kontrolovat, ze dany .prc soubor je typu 'appl'
  funkce CreateLink nebude otevirat soubor z karty, ale dostane soubor uz otevreny...
  'appl' se bud muze kontrolovat pri spusteni aplikace: zdlouhave
  nebo pri pozadavku na vytvoreni linku - asi tak...
  tj. v listboxu budou vsechny soubory .prc

***********************/

#include <stdarg.h>
void DEBUG (char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  FrmCustomAlert (show, b, "", "");
  va_end(p);
  MemPtrFree(b);
}

/************************************/
/******** common definitions ********/
/************************************/

// database type definition
#define AppID           'CLnk'
#define maxFiles        256

// global variables
UInt16          VolRef;
Char            *Files[maxFiles];
UInt16          fileCnt;
struct {
  UInt16        flags;
  Char          path[256];
} Prefs={0, "/PALM/Launcher/"};

Err CopyMyResource (DmOpenRef lnkdb, UInt32 type, UInt16 id, UInt16 newid) {
MemHandle hndl1, hndl2;
UInt32 size;

  if ((hndl1=DmGetResource (type, id))==NULL)
    return 1;
  if ((hndl2=DmNewResource (lnkdb, type, newid, size=MemHandleSize (hndl1)))==NULL)
    return 2;
  DmWrite (MemHandleLock (hndl2), 0, MemHandleLock (hndl1), size);
  MemHandleUnlock (hndl1);
  MemHandleUnlock (hndl2);
  DmReleaseResource (hndl2);
  return 0;
}

Err CopyAppResource (DmOpenRef lnkdb, FileRef file, UInt32 type, UInt16 id) {
MemHandle hndl;
Err err;

  err=errNone;
  if ((err=VFSFileDBGetResource (file, type, id, &hndl))==errNone)
    err=DmAttachResource (lnkdb, hndl, type, id);
  return err;
}

Err CreateLink (FileRef file, Char *AppName) {
Err             err;
MemHandle       hndl, hndl2;
UInt16          card;
LocalID         locid, curid;
UInt16          attr;
DmOpenRef       lnkdb;
Char            Name[40];
UInt32          Type, Creator, size;

  // retrieving Application name
  err=VFSFileDBInfo (file, Name, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &Type, &Creator, NULL);
  if (err!=errNone) return openError;
  if (Type!='appl') return wrongType;
  StrCat (Name, "@");
  // creating RAM resource database
  SysCurAppDatabase (&card, &curid);
  lnkdb=0;
  // selection: AppID (CardLink) creator or Creator (linked application) creator?
  // with CardLink's creatorID it behaves strange:-(
  //err=DmCreateDatabase (card, Name, AppID, 'appl', true);
  // so I use app's own creatorID
  err=DmCreateDatabase (card, Name, Creator, 'appl', true);
  if (err==dmErrAlreadyExists) 
    return alreadyExists;
  if (err!=errNone) return createError;
  if (!(locid=DmFindDatabase (card, Name))) return createError;
  // set backup attribute
  DmDatabaseInfo (card, locid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
  attr|=dmHdrAttrBackup;
  DmSetDatabaseInfo (card, locid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
  // opening created database
  if (!(lnkdb=DmOpenDatabase (card, locid, dmModeReadWrite))) return createError;
  // copying icons and basic resources
  CopyAppResource (lnkdb, file, 'tAIB', 1000);
  CopyAppResource (lnkdb, file, 'tAIB', 1001);
  CopyAppResource (lnkdb, file, 'tver', 1000);
  CopyAppResource (lnkdb, file, 'taic', 1000);
  // creating linked application path resource
  hndl=DmNewResource (lnkdb, 'tSTR', 0x2000, size=StrLen (AppName)+1);
  if (hndl!=NULL) {
    DmWrite (MemHandleLock (hndl), 0, AppName, size);
    MemHandleUnlock (hndl);
    DmReleaseResource (hndl);
  }
  // copying code resources from myself
  CopyMyResource (lnkdb, 'code', 0x2000, 0);
  CopyMyResource (lnkdb, 'code', 0x2001, 1);
  CopyMyResource (lnkdb, 'data', 0x2000, 0);
  CopyMyResource (lnkdb, 'pref', 0x2000, 0);
  CopyMyResource (lnkdb, 'rloc', 0x2000, 0);
  if (lnkdb) DmCloseDatabase (lnkdb);
  return errNone;
}

/******** main form handler ********/
static Boolean MainFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;
MemHandle       hndl;
ListPtr         lst;
Int16           idx;
Char            FileName[512];
FileRef         file;
Err             err;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_apps)), Files, fileCnt);
      LstSetSelection (lst, noListSelection);
      FldInsert (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, field_path)), Prefs.path, StrLen (Prefs.path));
      FrmDrawForm (frm);
      break;
    case frmCloseEvent:
      hndl=FldGetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, field_path)));
      StrCopy (Prefs.path, MemHandleLock (hndl));
      MemHandleUnlock (hndl);
      break;
    case menuEvent:
      handled=true;
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
        case menu_create:
          if ((idx=LstGetSelection (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_apps))))==noListSelection) break;
          StrCopy (FileName, Prefs.path);
          StrCat (FileName, Files[idx]);
          if ((err=VFSFileOpen (VolRef, FileName, vfsModeRead, &file))!=errNone) {
            FrmAlert (openError);
            break;
          }
          err=CreateLink (file, FileName);
          VFSFileClose (file);
          if (err!=errNone) {
            FrmAlert (err);
            break;
          }
          LstSetSelection (lst, noListSelection);
          break;
/**
        case menu_delete:
          break;
**/
        case menu_about:
          FrmHelp (str_about);
          break;
	default:
	  handled=false;
	  break;
      }
      break;
/**
    case keyDownEvent:
      switch (event->data.keyDown.chr) {
	default:
	  break;
      }
      break;
**/
/**
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case makelink:
          Iterator=vfsIteratorStart;
          if ((err=VFSVolumeEnumerate (&VolRef, &Iterator))!=errNone) break;
          CreateLink (VolRef, "/Palm/Launcher/MapView.prc");
          break;
	default:
	  break;
      }
      break;
**/
  }
  return handled;
}

/*********************************/
/******** basic functions ********/
/*********************************/

/******** startup setup ********/
static Err StartApplication(void) {
UInt32          version;
Err             err;
UInt16          idx;
Int16           k;
FileRef         dir;
FileInfoType    info;
Char            Name[256], *nptr;

  // initializing variables
  for (idx=0; idx<maxFiles; idx++)
    Files[idx]=NULL;
  fileCnt=0;
    
  // check for OS >=4.0 (VFS support)
  version=0;
  err = FtrGet (sysFtrCreator, sysFtrNumROMVersion, &version);
  if (version<0x04003000)
    return cannotRunApp;
  // check for Expansion Manager
  err = FtrGet (sysFileCExpansionMgr, expFtrIDVersion, &version);
  if (err)
    return cannotRunApp;
  // check for VFS Manager
  err = FtrGet (sysFileCVFSMgr, vfsFtrIDVersion, &version);
  if (err)
    return cannotRunApp;
  // loading preferences
  idx=0;
  if (PrefGetAppPreferences (AppID, 0, NULL, &idx, true)!=noPreferenceFound) {
    if (idx>sizeof (Prefs)) idx=sizeof (Prefs);
    PrefGetAppPreferences (AppID, 0, &Prefs, &idx, true);
  }
  Prefs.path[255]=0;

  // check for directory
  version=vfsIteratorStart;
  while (version!=vfsIteratorStop) {
    err = VFSVolumeEnumerate (&VolRef, &version);
    err = VFSFileOpen (VolRef, Prefs.path, vfsModeRead, &dir);
    if (err==errNone) break;
    dir=NULL;
  }
  if (!dir) return dirNotFound;
  // creating directory filelist
  version=vfsIteratorStart;
  info.nameP=Name;
  info.nameBufLen=256;
  while (fileCnt<maxFiles && version!=vfsIteratorStop) {
    err=VFSDirEntryEnumerate (dir, &version, &info);
    if (err!=errNone) break;
    // checking file extension
    for (idx=0; Name[idx]; idx++);
    for (; idx && Name[idx]!='.'; idx--);
    if (StrCaselessCompare (&Name[idx], ".PRC")) continue;
    if ((nptr=MemPtrNew (idx=StrLen (Name)+1))==NULL) {
      VFSFileClose (dir);
      return memoryError;
    }
    StrCopy (nptr, Name);
    // sorting name to right position
    for (idx=0; idx<fileCnt; idx++) {
      k=StrCompare (Name, Files[idx]);
      if (k<0) break;
    }
    for (k=fileCnt; k>idx; k--)
      Files[k]=Files[k-1];
    Files[k]=nptr;
    fileCnt++;
  }
  VFSFileClose (dir);
  if (!fileCnt) return noFilesFound;
  return 0;
}
/******** exit cleanup ********/
static void StopApplication (Err code) {
UInt16 idx;

  for (idx=0; idx<maxFiles; idx++)
    if (Files[idx]!=NULL) MemPtrFree (Files[idx]);
  // saving preferences
  PrefSetAppPreferences (AppID, 0, 0, &Prefs, sizeof (Prefs), true);
}
/******** event loop ********/
static void EventLoop(void) {
FormPtr         form;
EventType       event;
UInt16          err;

  do {
    EvtGetEvent (&event, evtWaitForever);
    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
    if (event.eType == frmLoadEvent) {
      FrmSetActiveForm (form=FrmInitForm (event.data.frmLoad.formID));
      switch (event.data.frmLoad.formID) {
	case main_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) MainFormHandler);
	  break;
      }
    }
    if (FrmDispatchEvent (&event)) continue;
  } while (event.eType != appStopEvent);
  FrmCloseAllForms ();
}
/******** entry point ********/
UInt32  PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
Err error;

  if (cmd!=sysAppLaunchCmdNormalLaunch)
    return 0;
  // application start-up part
  if (error=StartApplication ()) {
    FrmAlert (error);
    StopApplication (error);
    return error;
  }
  // display main form
  FrmGotoForm (main_form);
//  FrmGotoForm (setup_form);
  // event loop
  EventLoop ();
  // application end routine
  StopApplication (0);
  return 0;
}
