/*************************************
 RunLink 0.1
 (C) APR 2005 Hynek Sladky
 sladky@mujmail.cz
*************************************/

#pragma pack(2)

#include <PalmOS.h>
#include <ExpansionMgr.h>
#include <VFSMgr.h>

#include <PalmChars.h>

// resources header
#include "RunLinkR.h"

/******** ToDo ********/
/**********************


***********************/

/**
#include <stdarg.h>
void DEBUG (char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  FrmCustomAlert (show, b, "", "");
  va_end(p);
  MemPtrFree(b);
}
**/

/************************************/
/******** common definitions ********/
/************************************/

// database type definition
#define AppID           'CLnk'

/******** entry point ********/
UInt32  PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
Err err;
Char lapp[256];

UInt32          Iterator;
UInt16          VolRef;

UInt16          card;
LocalID         locid;

UInt16          attr;

  // if necessary, allow other launch codes (CmdGoto, CmdOpenDB, ...)
  // but this could require keeping original app's creatorID...
  if (cmd!=sysAppLaunchCmdNormalLaunch)
    return 0;
  // loading resource with linked application's name
  SysCopyStringResource (lapp, 0x2000);
  if (!*lapp) return 1;
  //DEBUG ("Running %s...", lapp);
  // copying linked application to RAM
  Iterator=vfsIteratorStart;
  if ((err=VFSVolumeEnumerate (&VolRef, &Iterator))!=errNone) return 2;
  err=VFSImportDatabaseFromFile (VolRef, lapp, &card, &locid);
  switch (err) {
    case errNone:
      // setting temporary flag
      DmDatabaseInfo (card, locid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      attr|=dmHdrAttrRecyclable;
      DmSetDatabaseInfo (card, locid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      break;
    case dmErrAlreadyExists:
      // alert if use existing application or overwrite with app from card???
      // or simply run app in RAM
      break;
    case expErrNotEnoughPower:
      FrmAlert (0x2001);
      return 3;
    case vfsErrBadName:
      FrmCustomAlert (0x2000, lapp, "", "");
      return 4;
    default:      
      return 5;
  }
  // running linked application
  SysUIAppSwitch (card, locid, sysAppLaunchCmdNormalLaunch, cmdPBP);
  return 0;
}
